var NamedStyles = /** @class */ (function () {
    function NamedStyles(styles, regex, pressFunctions) {
        this.styles = styles;
        this.regex = regex;
        this.pressFunctions = pressFunctions;
    }
    NamedStyles.prototype.validate = function (text) {
        var stylesIsObject = typeof this.styles === 'object' && !Array.isArray(this.styles);
        if (!stylesIsObject)
            return false;
        var _a = this.regex, TEXT_AMONG_BRACKETS = _a.TEXT_AMONG_BRACKETS, TEXT_WITH_BRACKETS = _a.TEXT_WITH_BRACKETS, KEY_VALUE_TEXT = _a.KEY_VALUE_TEXT;
        var textIsHighlighted = TEXT_WITH_BRACKETS.test(text);
        if (!textIsHighlighted)
            return false;
        var textIsKeyValue = text.split(TEXT_AMONG_BRACKETS).some(function (t) {
            var textIsKeyValueText = KEY_VALUE_TEXT.test(t);
            return textIsKeyValueText;
        });
        return textIsKeyValue;
    };
    NamedStyles.prototype.create = function (text) {
        var TEXT_AMONG_BRACKETS = this.regex.TEXT_AMONG_BRACKETS;
        var pureText = text.replace(TEXT_AMONG_BRACKETS, '$1');
        var _a = this.getProperties(pureText), finalText = _a[0], styles = _a[1], onPress = _a[2];
        return {
            text: finalText,
            styles: styles,
            onPress: onPress,
        };
    };
    NamedStyles.prototype.getProperties = function (value) {
        var _this = this;
        var _a = value.split('='), key = _a[0], text = _a[1];
        var keys = key.split(',');
        var styles = keys.map(function (key) { return _this.styles[key]; });
        var onPress = this.getOnPress(keys);
        return [text, styles, onPress];
    };
    NamedStyles.prototype.getOnPress = function (keys) {
        var _this = this;
        var _a, _b;
        var key = (_a = keys.find(function (value) { var _a; return ((_a = _this.pressFunctions) === null || _a === void 0 ? void 0 : _a[value]) !== undefined; })) !== null && _a !== void 0 ? _a : '';
        var onPress = (_b = this.pressFunctions) === null || _b === void 0 ? void 0 : _b[key];
        return onPress;
    };
    return NamedStyles;
}());
export { NamedStyles };
